﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using CareyGlass.AbstractBO.DataTypes;

namespace MyBO
{
    public static partial class TOrder 
    {
        public class Table : CareyGlass.AbstractBO.Table
        {
            public Table() : base() { CreateStructure(); }
            //protected internal Table() : base() { CreateStructure(); }
            protected Table(DataTable pDt) : base(pDt) { }

            protected override CareyGlass.AbstractBO.Row GetNewRow() { return new Row(); }
            protected override CareyGlass.AbstractBO.Subset GetEmptySubset() { return new Subset(); }

            internal void CreateStructure()
            {
                DataColumn c_orderNo = new DataColumn(FieldName.OrderNo, TType.Integer);
                DataColumn c_itemNo = new DataColumn(FieldName.ItemNo, TType.Integer);
                DataColumn c_typeID = new DataColumn(FieldName.TypeID, TType.Integer);
                DataColumn c_qty_1 = new DataColumn(FieldName.Qty_1, TType.Integer);
                DataColumn c_qty_2 = new DataColumn(FieldName.Qty_2, TType.Integer);

                c_orderNo.DefaultValue = 1;
                c_itemNo.DefaultValue = 1;
                c_typeID.DefaultValue = 0;

                dt.Columns.AddRange(new DataColumn[] { c_orderNo, c_itemNo, c_typeID, c_qty_1, c_qty_2 } );
            }

            public new Row NewRow() { return (Row)base.NewRow(); }
        }

        public class Row : CareyGlass.AbstractBO.Row
        {
            protected internal Row() : base() { }
            protected internal Row(DataRow pDr) : base(pDr) { }

            public Base.Row this[string pSuffix]
            {
                get { return new Base.RowProxy(pSuffix, base.dr); }
            }

            #region Properties

            public int OrderNo
            {
                get { return Convert.ToInt32(dr[FieldName.OrderNo]); }
                set { dr[FieldName.OrderNo] = value; }
            }

            public int ItemNo
            {
                get { return Convert.ToInt32(dr[FieldName.ItemNo]); }
                set { dr[FieldName.ItemNo] = value; }
            }


            public int TypeID
            {
                get { return Convert.ToInt32(dr[FieldName.TypeID]); }
                set { dr[FieldName.TypeID] = value; }
            }

            // Qty_1 & Qty_2 - isn't here. 
            // thay should be accessible over indexer.

            #endregion 
        }

        public class Subset : CareyGlass.AbstractBO.Subset
        {
            protected internal Subset() : base() { }
            protected Subset(DataRow[] pDra) : base(pDra) { }

            protected override CareyGlass.AbstractBO.Row GetRow() { return new Row(); }
            protected override CareyGlass.AbstractBO.Subset GetEmptySubset() { return new Subset(); }
        }

        public static class FieldName
        {
            const string Suffix_1 = "ABC";
            const string Suffix_2 = "DEF";

            public const string OrderNo = "OrderNo";
            public const string ItemNo = "ItemNo";
            public const string TypeID = "TypeID";
            public const String Qty_1 = "qty_" + Suffix_1;
            public const String Qty_2 = "qty_" + Suffix_2;
        }
    }
}
