﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Interfaces;
using PluginHandler.Interfaces;
using PluginHandler;

namespace Base
{
    public class RowProxy
    {
        static Dictionary<String, Row> dic = new Dictionary<string, Row>();

        string suffix;
        DataRow dr;

        public RowProxy(String pSuffix, DataRow pDr)
        {
            suffix = pSuffix;
            dr = pDr;
        }

        public static implicit operator Row(RowProxy pRowProxy)
        {
            Row temp;
            

            if (!dic.TryGetValue(pRowProxy.suffix, out temp))
            {
                IPlugin plugin = null;
                switch (pRowProxy.suffix)
                {
                    case "ABC":
                        plugin = PluginHandler.PluginHostProvider.GetPlugin("ABC");
                        break;
                    case "DEF":
                        plugin = PluginHandler.PluginHostProvider.GetPlugin("DEF");
                        break;
                }
                temp = plugin as Row;
                dic.Add(pRowProxy.suffix, temp);
            }
            temp.Dr = pRowProxy.dr;

            return temp;
        }
    }
}
